import _toConsumableArray from "@babel/runtime/helpers/esm/toConsumableArray";
//  weak
import Brush from "@mui/icons-material/Brush";
import TrashIcon from "@mui/icons-material/Delete";
import ReorderIcon from "@mui/icons-material/SwapVert";
import { Grid } from "@mui/material";
import * as colors from "@mui/material/colors";
import { grey } from "@mui/material/colors";
import { createTheme, styled, ThemeProvider } from "@mui/material/styles";
import { makeStyles } from "@mui/system";
import classnames from "classnames";
import React from "react";
import getTimeString from "../KeyframeTimeline/get-time-string.js";
import styles from "../RegionSelectorSidebarBox/styles.js";
import SidebarBoxContainer from "../SidebarBoxContainer";
var theme = createTheme();
var KeyframeRow = styled("div")(function (_ref) {
  var theme = _ref.theme;
  return {
    cursor: "pointer",
    display: "flex",
    alignItems: "center",
    padding: 8,
    fontSize: 14,
    color: colors.grey[700],
    "&.current": {
      backgroundColor: colors.blue[100]
    },
    "&:hover": {
      backgroundColor: colors.grey[100]
    },
    "& .time": {
      flexGrow: 1,
      fontWeight: "bold",
      "& .regionCount": {
        marginLeft: 8,
        fontWeight: "normal",
        color: colors.grey[500]
      }
    },
    "& .trash": {
      "& .icon": {
        fontSize: 18,
        color: colors.grey[600],
        transition: "transform 80ms",
        "&:hover": {
          color: colors.grey[800],
          transform: "scale(1.25,1.25)"
        }
      }
    }
  };
});
var useStyles = makeStyles(function (theme) {
  return styles;
});
var HeaderSep = styled("div")(function (_ref2) {
  var theme = _ref2.theme;
  return {
    borderTop: "1px solid ".concat(grey[200]),
    marginTop: 2,
    marginBottom: 2
  };
});
var RowLayout = function RowLayout(_ref3) {
  var order = _ref3.order,
    classes = _ref3.classes,
    title = _ref3.title,
    trash = _ref3.trash;
  return /*#__PURE__*/React.createElement("div", {
    className: classnames(classes.row)
  }, /*#__PURE__*/React.createElement(Grid, {
    container: true,
    alignItems: "center"
  }, /*#__PURE__*/React.createElement(Grid, {
    item: true,
    xs: 2
  }, order), /*#__PURE__*/React.createElement(Grid, {
    item: true,
    xs: 5
  }, title), /*#__PURE__*/React.createElement(Grid, {
    item: true,
    xs: 2
  }, /*#__PURE__*/React.createElement("div", {
    style: {
      textAlign: "right",
      paddingRight: 6
    }
  })), /*#__PURE__*/React.createElement(Grid, {
    item: true,
    xs: 1
  }, " "), /*#__PURE__*/React.createElement(Grid, {
    item: true,
    xs: 1
  }), /*#__PURE__*/React.createElement(Grid, {
    item: true,
    xs: 1
  }, trash)));
};
var BrushKeyFrame = function BrushKeyFrame(_ref4) {
  var currentVideoTime = _ref4.currentVideoTime,
    setdelete_annotation = _ref4.setdelete_annotation,
    onChangeVideoTime = _ref4.onChangeVideoTime,
    setLines = _ref4.setLines,
    brushLines = _ref4.brushLines,
    delete_annotation = _ref4.delete_annotation;
  var classes = useStyles();
  var brush_region_arr = brushLines === null || brushLines === void 0 ? void 0 : brushLines.filter(function (arr, index, self) {
    return index === self.findIndex(function (t) {
      return t.id === arr.id || t.keyframes === arr.keyframes && arr.id;
    });
  });
  return /*#__PURE__*/React.createElement(ThemeProvider, {
    theme: theme
  }, /*#__PURE__*/React.createElement(SidebarBoxContainer, {
    title: "Brush Keyframes",
    subTitle: "",
    icon: /*#__PURE__*/React.createElement(Brush, {
      style: {
        color: colors.grey[700]
      }
    }),
    expandedByDefault: true
  }, /*#__PURE__*/React.createElement("div", {
    className: classes.container
  }, /*#__PURE__*/React.createElement(RowLayout, {
    classes: classes,
    order: /*#__PURE__*/React.createElement("div", {
      style: {
        textAlign: "right",
        paddingRight: 10
      }
    }, /*#__PURE__*/React.createElement(ReorderIcon, {
      className: "icon"
    })),
    title: /*#__PURE__*/React.createElement("div", {
      style: {
        paddingLeft: 10
      }
    }, "Timeline"),
    trash: /*#__PURE__*/React.createElement("div", {
      className: "trash"
    }, /*#__PURE__*/React.createElement(TrashIcon, {
      onClick: function onClick(e) {
        setLines([]);
        window.undoBrush();
        var arr = _toConsumableArray(delete_annotation);
        setdelete_annotation(arr);
        e.stopPropagation();
      },
      className: "icon"
    }))
  }), /*#__PURE__*/React.createElement(HeaderSep, null), brush_region_arr.map(function (t, index) {
    return /*#__PURE__*/React.createElement(RowLayout, {
      key: t,
      classes: classes,
      order: /*#__PURE__*/React.createElement("div", {
        style: {
          textAlign: "center"
        }
      }, "#", index + 1),
      title: /*#__PURE__*/React.createElement("div", {
        style: {
          paddingLeft: 10
        },
        onClick: function onClick() {
          return onChangeVideoTime(t === null || t === void 0 ? void 0 : t.keyframe);
        }
      }, /*#__PURE__*/React.createElement("div", {
        className: "time"
      }, getTimeString((t === null || t === void 0 ? void 0 : t.keyframes) || 0, 2), /*#__PURE__*/React.createElement("span", {
        className: "regionCount"
      }, "\xA0(", t.tool, ")"))),
      trash: /*#__PURE__*/React.createElement("div", {
        className: "trash"
      }, /*#__PURE__*/React.createElement(TrashIcon, {
        onClick: function onClick(e) {
          var linessave = _toConsumableArray(brushLines);
          var filter_arr = linessave.filter(function (filters) {
            return filters.id !== t.id && filters;
          });
          setLines(filter_arr);
          var arr = _toConsumableArray(delete_annotation);
          var delete_arr = linessave.filter(function (filter) {
            return filter.id === t.id && filter;
          });
          arr.push(delete_arr);
          window.undoArray = [].concat(_toConsumableArray(window.undoArray), ["delete~".concat(t.id)]);
          /** create DeleteBrush Arr */
          window.deleteBrush = [].concat(_toConsumableArray(window.deleteBrush), [arr]).flat();
          setdelete_annotation(arr.flat());
          window.brushHighlighted(-1);
          e.stopPropagation();
        },
        className: "icon"
      }))
    });
  }))));
};
export default BrushKeyFrame;